function frmMainLoaded()
	print("Running RunOnce();");
	tinsert(UISpecialFrames,"frmMain");
	tinsert(UISpecialFrames,"frmOfficer");
    frmMain:RegisterForDrag("LeftButton");
	frmMain:UnregisterEvent("PLAYER_ENTERING_WORLD");
	frmOfficer:RegisterEvent("CHAT_MSG_ADDON");
	frmOfficer:RegisterEvent("PARTY_LOOT_METHOD_CHANGED");
	frmOfficer:RegisterForDrag("LeftButton");
	RegisterAddonMessagePrefix("lgoh");
	
	if(init~=nil) then
		RunOnce();
	end
	
	btnHatfield:SetText(legend);
	edtLegend:SetText(legend);
	edtLegend_Short:SetText(legend_short);
	
	-- Version Print
	if(oldversion==nil) then oldversion="1"; end -- Fix a bug when comparing to oldversion=nil
	vers = GetAddOnMetadata("ELGoH", "X-Curse-Packaged-Version") 
	vers = string.sub(vers, 1);
	if(vers>oldversion or playername=="Taurast") then
		print("Welcome to ELGoH "..vers..".\nType /elgoh info for a list of commands.");
		oldversion=vers;
	end
	-- End Version Print
	
end

function RunOnce()
	if(GetNumGuildMembers(1)==0) then
		print("An error has occurred, you are not in a guild?");
	else
		for i = 1, GetNumGuildMembers(0), 1 do 
			name, rank, rankIndex, level, class = GetGuildRosterInfo(i);
			if(name==UnitName("player")) then
				playername, playerrealm=UnitName("player");
				playerrank=rankIndex;
				playerguild=GetGuildInfo("player");
				if(legend==nil) then legend="Chuck Norris"; end
				if(legend_short==nil) then legend_short="Chuck"; end
				break;
			end
		end
	end
	init=1;
end

function BreakTimer()
	SendChatMessage("Breaktime!", "RAID")
	DBM:CreatePizzaTimer(600, "Breaktime", 1, "The Officers")
end

function lgohInfo()
	print("|cFF00FF00Welcome to the LGoH addon! If you find anything that doesn't work (or does work), or something you feel could do with a little tweaking feel free to message me in game :)\n");
	print("|cFF00FF00If a box is left blank, it will apply to yourself, or your target if you have one");
	print("|cFF00FF00Shift Clicking the top button in the Fun Panel will allow you to change the legendary character in the Legend Facts database (a few of them will have bad grammar)");
	print("|cFF8888FFAvailable commands:\n/elgoh\n/elgoh info\n/elgoh officer\n/elgoh startdkp - generates a start bonus string for GuildLaunch\n/elgoh clean - Cleans members offline for more than 29 days");
end
   
function possessTarget()
	if(UnitName("target")~=nil) then
		if(pA==nil) then
			print("You must type \"/anoo possess-allow\" to enable this feature. Warning, you will be vulnerable to possessions as well");
		else
			SendAddonMessage("lgoh", edtPTarget:GetText(), "WHISPER", UnitName("target"));
		end
	else
		print("No Target");
	end
end

function possessed(event, ...)
	if(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = select(1, ...);
		if(prefix=="lgoh") then
			if(pA==1) then
				print(who.." possessed you...");
				if(GetNumRaidMembers()>1) then
					SendChatMessage(msg, RAID);
				elseif(GetNumPartyMembers()>1) then
					SendChatMessage(msg, PARTY);
				else
					SendChatMessage(msg, SAY);
				end
			else
				print(who.." tried to possess you");
			end
		end
	end
	if(event=="PARTY_LOOT_METHOD_CHANGED") then
		lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod();
		if(lootmethod=="master") then
			if(masterlooterRaidID) then
				name = GetRaidRosterInfo(masterlooterRaidID);
			elseif(masterlooterPartyID) then
				name = GetRaidRosterInfo(masterlooterPartyID);
			end
			if(name~=nil and name~="") then
				edtMaster:SetText("Master Looter: "..name);
			end
		end
	end
end

function Rottgut()
	for i = 1, GetNumGuildMembers(1), 1 do 
		yearsOffline, monthsOffline, daysOffline, hoursOffline = GetGuildRosterLastOnline(i);
		name, rank, rankIndex, level, class, zone, note, officernote, online = GetGuildRosterInfo(i);
		if((online~=1 and (daysOffline>=20 and rankIndex==7) and level<=50)) then 
			print("Kicking "..name..": Inactive Alt")
			GuildUninvite(name);
		elseif((online~=1 and (daysOffline>=29 or monthsOffline>0) and officernote~="NoKick")) then
			print("Kicking "..name..": Inactive Member")
			GuildUninvite(name);
		end
	end
end

function PostTo_OnClick(self)
  local i = self:GetID()
  UIDropDownMenu_SetSelectedID(DropPostTo, i)
end

function PostTo_OnShow()
	UIDropDownMenu_Initialize(DropPostTo,PostTo_Initialize)
	UIDropDownMenu_SetSelectedID(DropPostTo, 1)
end

function PostTo_Initialize()
	PostToChoice = {"|cff00ff00Guild", "|cffff4444Raid", "|cff6655ffParty", "Say", "|cff999999Self"};
	local i
	if(getn(PostToChoice) > 0) then
		for i = 1, getn(PostToChoice), 1 do
			info = {
				text = PostToChoice[i],
				func = PostTo_OnClick
			}
			UIDropDownMenu_AddButton(info)
		end
	end
end

SLASH_LGOH1 = "/lgoh"
SlashCmdList["LGOH"] = function(msg, editBox)
msg = strlower(msg);
    if(msg=="officer" or msg=="o") then
		if (playerrank==0 or playerrank==1 or playerrank==2) then
			frmOfficer:Show();
		else
			print("You are not ranked high enough at "..playerrank..", requires 0 or 1 or 2");
		end
    elseif(msg=="rottgut" or msg=="clean") then
		if (playerrank==0 or playerrank==1 or playerrank==2) then
			Rottgut();
		else
			print("You are not ranked high enough at "..playerrank..", requires 0 or 1 or 2");
		end
	elseif(msg=="info") then
		lgohInfo()
	elseif(msg=="startdkp") then
		StartDKP()
	else
		frmMain:Show();
    end
end

SLASH_ELGOH1 = "/elgoh"
SlashCmdList["ELGOH"] = function(msg, editBox)
    if(msg=="officer" or msg=="o") then
		if (playerrank==0 or playerrank==1) then
			frmOfficer:Show();
		else
			print("You are not ranked high enough at "..playerrank..", requires 0 or 1");
		end
	elseif(msg=="clean") then
		if (playerrank==0 or playerrank==1) then
			Rottgut();
		else
			print("You are not ranked high enough at "..playerrank..", requires 0 or 1");
		end
	elseif(msg=="info") then
		lgohInfo()
	elseif(msg=="startdkp") then
		StartDKP()
	else
		frmMain:Show();
    end
end

SLASH_ANOO1 = "/anoo"
SlashCmdList["ANOO"] = function(msg, editBox)
	if(msg=="dev") then
		devel=1;
	elseif(msg=="possess-allow") then
		pA=1;
		print("Allowing Possessions, type /anoo possess-disable");
	elseif(msg=="possess-disable") then
		pA=0;
		print("Disabling Possessions");
	else
		ReloadUI();
	end
end

function SetMaster()
if(edtMaster:GetText()=="Not Set" or edtMaster:GetText()=="") then 
	edtMaster:SetText("Not Set");
	if(UnitName("target")==nil) then 
		SetLootMethod("master", UnitName("player"));
		SetLootThreshold(3);
		edtMaster:ClearFocus();
	else
		SetLootMethod("master", UnitName("target"));
		SetLootThreshold(3);
		edtMaster:ClearFocus();
	end
else
	SetLootMethod("master", edtMaster:GetText());
	SetLootThreshold(3);
	edtMaster:ClearFocus();
end
end

function Blame()
		if(UIDropDownMenu_GetSelectedID(DropPostTo)==2 and GetNumRaidMembers()) then
			i = random(1,GetNumRaidMembers());
			name = GetRaidRosterInfo(i);
			PostTo("I blame " ..name.. ".");
		elseif (UIDropDownMenu_GetSelectedID(DropPostTo)==1) then
			guildies=GetNumGuildMembers(false);
			i = math.random(1, guildies); 
			name, rank, rankIndex, level, class, zone, note, officernote, online = GetGuildRosterInfo(i);
			if(online) then 
				PostTo("I blame " ..name.. ".");
			else
				Blame();
			end
		end
	edtBlame:ClearFocus();
end

function PostTo(str)
		if (UIDropDownMenu_GetSelectedID(DropPostTo)<5) then 
			SendChatMessage(str, PostToChoice[UIDropDownMenu_GetSelectedID(DropPostTo)]); 
		else
			print(str); 
		end
end

function RandomJoke()
	local RANDOM_JOKES = { 
			"Can atheists get insurance for acts of God?",
			"Does the name Pavlov ring a bell? ",
			"Do illiterate people get the full effect of alphabet soup? ",
			"If love is blind, is lingerie considered Braille? ",
			"Is it true that cannibals don't eat clowns because they taste funny?  ",
			"What would the world be like without hypothetical situations?",
			"Owners of digital watches: Your day's are numbered!  ",
			"A printer consists of three main parts: the case, the jammed paper tray and the blinking red light. ",
			"A user friendly computer first requires a friendly user. ",
			"There are only 10 types of people in this world: those who understand binary, those who don't and those who are tired of this joke. ",
			"What was ET short for? 'cause he has wee legs! "};	
	local index = random(1, #RANDOM_JOKES);
	local str = RANDOM_JOKES[index];
	PostTo(str);
end

function RandomFact()
	local ALL_FACTS = {
					"Odontophobia is the fear of teeth. ",
					"The 57 on Heinz ketchup bottles represents the number of varieties of pickles the company once had. ",
					"The surface area of an average-sized brick is 79 cm squared.  ",
					"According to suicide statistics, Monday is the favored day for self-destruction. ",
					"Cats can sleep 16 to 18 hours per day. ",
					"Karaoke means empty orchestra in Japanese.  ",
					"The first known contraceptive was crocodile dung, used by Egyptians in 2000 B.C. ",
					"The most money ever paid for a cow in an auction was $1.3 million.  ",
					"The Neanderthal's brain was bigger than yours is. ",
					"The sound of E.T. walking was made by someone squishing her hands in jelly. ",
					"There are 10 human body parts that are only 3 letters long (eye hip arm leg ear toe jaw rib lip gum). ",
					"The king of hearts is the only king without a moustache.  ",
					"The word lethologica describes the state of not being able to remember the word you want. ",
					"In the average lifetime, a person will walk the equivalent of 5 times around the equator. " };
	local index = random(1, #ALL_FACTS);
	local str = ALL_FACTS[index];
	PostTo(str);
end